# -*- coding: utf-8 -*-
require 'pry'

#Definicion de nodo como un Struct
Nodo = Struct.new(:value, :next, :previus)

#Nodo como objeto comparable y ordenable (se mira el valor que contiene)
class Nodo
    include Comparable
    def <=> (other)
        value <=> other.value
    end
end

#Clase lista, que representa una lista simplemente enlazada de nodos
class Lista
        include Enumerable
        
#Método constructor
        def initialize
                @head = nil
                @tail = nil
        end

#Coloca un nuevo nodo como cabeza (push)
        def addn(nodo2)  #coloca un nuevo nodo como cabeza !push
            nodo = Nodo.new()
            
            if (nodo2.class == Nodo)
                    nodo = nodo2
            else
                nodo.value = nodo2
            end
            
            nodo.next = @head

            if (!@head.nil? && @head.next.nil?)
                @tail = @head
                @tail.next = nil
            end
            
            if (!head.nil?)
                @head.previus = nodo
            end

            nodo.previus = nil
#si en vez de nil ponemos tail, es una lsita circular, es decir unimos head con tail en previus
            
            @head = nodo
           
#@tail.next = @head añadir esto para que la lista sea circular tail apuntara a head como siguiente
        end

#Elimina el nodo cabeza (pop)
        def deln
            aux = @head
            if (@head.next.nil?)
                @tail = nil
                @head = nil
            else
                @head = @head.next
                @head.previus = @tail
            end
            aux.value
        end
        
#Devuelve el nodo que esta en cabeza
        def head
            @head
        end

#Devuelve el nodo que está al final
        def tail
            @tail
        end
        
#Método que sirve para iterar por todos los nodos de la lista
        def each(&block)
            current_node = @head
            
            while current_node != nil
                block.call(current_node)
                current_node = current_node.next
            end
        end
        
#Método que sirve para ordenar la lista.
        def ordenar()
           contador = (self.count)
           contador = contador-1
           aux = self.sort
           @head = nil
           @tail = aux[0]
           while (contador >= 0) do
                self.addn(aux[contador])
                contador = contador-1
           end
           
        end
        
#Devuelve la lista como String (usado en testeo)
        def to_s    #para testear
            self.each do |l|
                print l.value.to_s + " -> "
            end
            puts ""
        end
end

